#!/usr/bin/env python

cdef extern from "Python.h":
    object PyString_FromStringAndSize(char *, int)

def vint(int number):

    cdef char bytes[40] # NOTE: Arbitrary limit.
    cdef int lsd, i

    if number < 128:
        bytes[0] = number
        s = PyString_FromStringAndSize(bytes, 1)
        return s

    i = 0
    while number != 0:
        lsd = number & 127
        number = number >> 7
        if number != 0:
            lsd = lsd | 128
        bytes[i] = lsd
        i = i + 1

    s = PyString_FromStringAndSize(bytes, i)
    return s

# vim: tabstop=4 expandtab shiftwidth=4
